# c3270 Resources

Resources are used to configure c3270. Resources are named items with string, integer or Boolean values.

Resource definitions come from the following sources:

- Default values are compiled into c3270.
- If a session file foo.c3270 is specified on the command line, its contents are applied. Otherwise, if the c3270 profile (~/.c3270pro) exists, it is read and its contents are applied. These definitions override resource values defined by compiled-in defaults.
- Command-line options override all other resource definitions. If more than one command-line option sets a resource, the last one is used.

Many resources have their own command-line switches, which are listed below. Those that do not can still be set from the command-line via the -xrm command-line option. For example c3270.bsdTm can be set by the following command-line option:

         -xrm "c3270.bsdTm: true"

Note that -xrm is supported on all of the 3270 emulators, not just on x3270.

## Resource File Syntax

A resource file (profile or session file) has the following syntax.

- Each definition consists of:

          c3270.resource-name: value

- Comment lines begin with !.
- Line continuation is indicated by a backshash (\) character at the end of a line.
- Multi-line resources, such as keymap definitions, are split with newline characters, e.g.:

          c3270.keymap.foo: \
            <Key>a: String("bob") \n\
            <Key>b: String("fred") \n\
            <Key>c: String("joe")

## Alphabetical Resource List

Name: c3270.acceptHostname
Type: String
Command Line: -accepthostname
Description:

Defines a specific name to accept when validating the name presented in the server's SSL/TLS certificate, instead of using the name used to make the connection. (The form DNS:name is also accepted for backwards compatibility.)

Name: c3270.acs
Type: Boolean
Default: true
Description:

When true, c3270 will use the curses Alternative Character Set (ACS) to display box-drawing characters. When false, c3270 will use Unicode box-drawing characters.

Name: c3270.aidWait
Type: Boolean
Default: false
Command Line: -set aidWait , -clear aidWait
Description:

When true, c3270 will not block a script after executing an AID action (Enter, Clear, PF or PA). It is then script's responsibility to poll c3270's status until it shows that the keyboard is no longer unlocked.

Name: c3270.allBold
Type: String
Default: auto
Command Line: -allbold
Description:

When true, c3270 will display all text in bold. This is needed for terminals like Linux consoles and xterms that display non-bold text in unreadably-dim colors. When false, text will be displayed in normal or bold, depending on the host-specified highlighting attribute.

When set to auto, it will be assumed true for 3279 emulation, and false for 3278 emulation.

Name: c3270.altScreen
Type: String
Command Line: -altscreen
Description:

Defines a character string that will be output to switch the terminal from 80-column mode to 132-column mode. Within the string, the sequence \E is translated to the ASCII ESC character (0x1b).

When c3270.model is 5, and this and c3270.defScreen are defined, c3270 will automatically change the terminal size when the host switches between the default (24x80) screen and the alternate (27x132) screen.

Name: c3270.asciiBoxDraw
Type: Boolean
Default: false
Description:

When true, this causes box-drawing characters (the Unicode 2500 block) to be drawn with ASCII-art characters (+, - and |). This allows a readable representation of these characters on the screen when using fonts that do not include them or have them with the wrong width.

Name: c3270.bindLimit
Type: Boolean
Default: true
Description:

When true, c3270 will restrict its screen dimensions to those specified in the BIND image sent by the host. If false, it will not.

Name: c3270.bindUnlock
Type: Boolean
Default: false
Description:

When true, c3270 will unlock the keyboard as soon as the host sends a BIND image. Otherwise, it will wait until the host sends a Write command.

Note that in some previous releases, unlocking as soon as the BIND image was recevied was the default, and this behavior could be overridden (forcing c3270 to wait for the Write) by the B: option on the hostname. Since waiting for the Write is now the default, B: is still supported as a no-op.

Name: c3270.blankFill
Type: Boolean
Default: false
Command Line: -set blankFill , -clear blankFill
Description:

When true, in 3270 mode c3270 will automatically convert trailing blanks in a field to NULLs in order to insert a character, and will automatically convert leading NULLs to blanks so that input data is not squeezed to the left. This works around some of the quirkier behavior of real 3270 terminals.

Name: c3270.bsdTm
Type: Boolean
Default: false
Description:

Defines c3270's response to the TELNET DO TIMING MARK option. When set to false, c3270 will respond to DO TIMING MARK with WONT TIMING MARK, which is consistent with most modern TELNET clients. When true, c3270 will respond with WILL TIMING MARK, which is consistent with the old BSD telnet command and with previous versions of c3270. In either case, c3270 will never respond to a DONT TIMING MARK option.

Name: c3270.caDir
Type: String
Command Line: -cadir
Description:

Defines a directory containing CA (root) certificates, used to validate a certificate presented by the host during SSL/TLS negotiation. The default is determined by the OpenSSL library on your workstation. (OpenSSL only)

Name: c3270.caFile
Type: String
Command Line: -cafile
Description:

Defines a PEM-format file containing CA (root) certificates, used to validate a certificate presented by the host during SSL/TLS negotiation. The default is determined by the OpenSSL library on your workstation. (OpenSSL only)

Name: c3270.cbreak
Type: Boolean
Default: false
Command Line: -cbreak
Description:

If true, c3270 will set up the terminal in cbreak mode instead of the default raw mode. Cbreak mode enables flow-control processing in the TTY driver, and may be required for certain terminals that use flow control to avoid dropping characters.

Name: c3270.certFile
Type: String
Command Line: -certfile
Description:

Gives the name of a client certificate file, provided to the host during SSL/TLS negotiation.

With OpenSSL, the default file format is PEM; it can be overridden by c3270.certFileType. The private key for the certificate is specified by c3270.keyFile. If c3270.chainFile is specified, it overrides c3270.certFile.

On the Mac, the file must be in PKCS12 format.

Name: c3270.certFileType
Type: String
Default: pem
Command Line: -certfiletype
Description:

Gives the type of the certificate file specified by c3270.certFile. The value can be pem or asn1. (OpenSSL only)

Name: c3270.chainFile
Type: String
Command Line: -chainfile
Description:

Gives the name of a certificate chain file to provided to the host during SSL/TLS negotiation. The file contains a PEM-format certificate, optionally followed by any intermediate certificates used to sign it, and the CA (root) certificate. The private key for the certificate is specified by c3270.keyFile. If c3270.chainFile is specified, it overrides c3270.certFile. (OpenSSL only)

Name: c3270.charset
Type: String
Default: bracket
Command Line: -charset
Description:

This defines the host EBCDIC character set, that is, what glyph (image) is displayed for each EBCDIC code sent by the host, and what EBCDIC code is sent to the host for each character typed on the keyboard. This is more correctly referred to as the host code page.

To display the character sets supported by c3270, use the -v command-line option.

Name: c3270.clientCert
Type: String
Command Line: -clientcert
Description:

Gives the name of a client certificate, provided during SSL/TLS negotiation. (Mac only)

Name: c3270.color8
Type: Boolean
Default: false
Description:

If true, c3270 will respond to a Query(Color) with a list of 8 supported colors. If false, it will send a list of 16 colors. The 8-color setting is required for some hosts which abort a session if 16 colors are reported.

This setting will also cause c3270 to assume that the terminal supports no more than 8 colors, and will use only the 8 basic curses colors to draw the screen.

Name: c3270.composeMap
Type: String
Default: latin1
Description:

Gives the name of the map used to define the pairs of characters that form composite characters with the Compose key. The definition of compose map foo is the resource c3270.composeMap.foo.

Name: c3270.composeMap.foo
Type: String
Description:

An individual compose map definition. Each line in the resource is of the form:

             keysym1 + keysym2 = keysym3

meaning "when the Compose key is pressed, followed by keysym1 and keysym2 (in either order), interpret it as keysym3." The definitions are case-sensitive.

Name: c3270.confDir
Type: String
Default: /usr/local/etc/x3270
Description:

Defines the c3270 configuration directory, where c3270 will search for the ibm_hosts file by default. (See c3270.hostsFile.)

Name: c3270.connectTimeout
Type: Integer
Command Line: -connecttimeout
Description:

Specifies a timeout, in seconds, that c3270 will wait for a host connection to complete. If this is not set, the timeout will be determined by the operating system. Note that c3270 will wait for the lesser of the two times (the specified timeout and the system-defined timeout).

Name: c3270.crosshair
Type: Boolean
Default: false
Command Line: -set crosshair , -clear crosshair
Description:

When true, causes c3270 to display a crosshair over the cursor: lines extending with height and width of the screen.

Name: c3270.crosshairColor
Type: String
Default: purple
Description:

Defines the color used for the crosshair cursor (see c3270.crosshair). The value is a host color name or numeric host color index:

Host Color Name | Host Color Index
--- | ---
NeutralBlack | 0
Blue | 1
Red | 2
Pink | 3
Green | 4
Turquoise | 5
Yellow | 6
NeutralWhite | 7
Black | 8
DeepBlue | 9
Orange | 10
Purple | 11
PaleGreen | 12
PaleTurquoise | 13
Grey | 14
White | 15

Name: c3270.cursesColorForDefault
Name: c3270.cursesColorForIntensified
Name: c3270.cursesColorForProtected
Name: c3270.cursesColorForProtectedIntensified
Type: String
Description:

Defines the default color to use to render text based on its attributes, when the host does not specify a particular color.

The value of the resource can be either a curses color index or curses color name. These are are defined as follows:

Curses Color Index | Curses Color Name
--- | ---
0 | black
1 | red
2 | green
3 | yellow
4 | blue
5 | magenta
6 | cyan
7 | white
8 | no name -- displays as grey
9 | no name -- displays as bright red
10 | no name -- displays as bright green
11 | no name -- displays as bright yellow
12 | no name -- displays as bright blue
13 | no name -- displays as bright magenta
14 | no name -- displays as bright cyan
15 | no name -- displays as bright white

The default values are:

c3270 Resource | Default Curses Color (8-color terminal) | Default Curses Color (16-color terminal)
--- | --- | ---
cursesColorForDefault | green | 10 (bright green)
cursesColorForIntensified | red | red
cursesColorForProtected | blue | 12 (bright blue)
cursesColorForProtectedIntensified | white | 15 (bright white)

Name: c3270.cursesColorForHostColor0
Name: c3270.cursesColorForHostColorNeutralBlack
Name: c3270.cursesColorForHostColor1
Name: c3270.cursesColorForHostColorBlue
Name: c3270.cursesColorForHostColor2
Name: c3270.cursesColorForHostColorRed
Name: c3270.cursesColorForHostColor3
Name: c3270.cursesColorForHostColorPink
Name: c3270.cursesColorForHostColor4
Name: c3270.cursesColorForHostColorGreen
Name: c3270.cursesColorForHostColor5
Name: c3270.cursesColorForHostColorTurquoise
Name: c3270.cursesColorForHostColor6
Name: c3270.cursesColorForHostColorYellow
Name: c3270.cursesColorForHostColor7
Name: c3270.cursesColorForHostColorNeutralWhite
Name: c3270.cursesColorForHostColor8
Name: c3270.cursesColorForHostColorBlack
Name: c3270.cursesColorForHostColor9
Name: c3270.cursesColorForHostColorDeepBlue
Name: c3270.cursesColorForHostColor10
Name: c3270.cursesColorForHostColorOrange
Name: c3270.cursesColorForHostColor12
Name: c3270.cursesColorForHostColorPurple
Name: c3270.cursesColorForHostColor13
Name: c3270.cursesColorForHostColorPaleGreen
Name: c3270.cursesColorForHostColor14
Name: c3270.cursesColorForHostColorPaleTurquoise
Name: c3270.cursesColorForHostColor15
Name: c3270.cursesColorForHostColorGrey
Name: c3270.cursesColorForHostColor16
Name: c3270.cursesColorForHostColorWhite
Type: String
Description:

Defines what curses color to use to render a particular host color. Host colors can be specified by name or number. That is, to define the curses color to use when the host specifies green, which is host color 4, either the resource c3270.cursesColorForHostColorGreen or the resource c3270.cursesColorForHostColor4 can be defined.

The default definitions are as follows. Note that on an 8-color terminal, c3270 only displays 8 host colors.

Host Color Index | Host Color Name | Default Curses Color (8-color terminal) | Default Curses Color (16-color terminal)
--- | --- | --- | ---
0 | NeutralBlack | black | black
1 | Blue | blue | 12 (bright blue)
2 | Red | red | red
3 | Pink | red | 13 (bright magenta)
4 | Green | green | 10 (bright green)
5 | Turquoise | cyan | 14 (bright cyan)
6 | Yellow | yellow | 11 (bright yellow)
7 | NeutralWhite | white | 15 (bright white)
8 | Black | - | black
9 | DeepBlue | - | blue
10 | Orange | - | 9 (bright red)
11 | Purple | - | magenta
12 | PaleGreen | - | green
13 | PaleTurquoise | - | cyan
14 | Grey | - | white
15 | White | - | 15 (bright white)

Note that "neutral black" means black on a display device and white on a printing device, and "neutral white" means white on a display device and black on a printing device.

In NVT mode, c3270 maps the ANSI-standard colors 0 through 7 to host colors, and from host colors to curses colors. The mapping from ANSI colors to host colors cannot be changed, but the mapping from host colors to curses colors can be with c3270.cursesColorForHostColor* resources. The mappings and defaults are as follows:

NVT ANSI Color | Mapped Host Color (not configurable) | Default Curses Color (8-color terminal) | Default Curses Color (16-color terminal)
--- | --- | --- | ---
0 (black) | 0 (Black) | black | black
1 (red) | 2 (Red) | red | red
2 (green) | 4 (Green) | green | 10 (bright green)
3 (yellow) | 6 (Yellow) | yellow | 11 (bright yellow)
4 (blue) | 1 (Blue) | blue | 12 (bright blue)
5 (magenta) | 3 (Pink) | red | 13 (bright magenta)
6 (turquoise) | 13 (PaleTurquioise) | cyan | cyan
7 (white) | 15 (White) | white | 15 (bright white)

See c3270.cursesColorForDefault for the definitions of curses colors.

Name: c3270.cursesKeypad
Type: Boolean
Default: false
Description:

When true, c3270 will set up the terminal in curses keypad mode.

Name: c3270.cursorPos
Type: Boolean
Default: true
Command Line: -set cursorPos , -clear cursorPos
Description:

When true, causes c3270 to display the cursor location in the OIA (the status line).

Name: c3270.dbcsCgcsgid
Type: String
Description:

Overrides the compiled-in value of the CGCSGID for the current host character set, which will be reported to the host in response to a Query(Character Sets). The value is an integer, which can be prefixed with '0x' to be in hexadecimal. The upper 16 bits are the GCSGID (character set) and the lower 16 bits are the CPGID (code page). This value applies only to the double-byte (DBCS) character set. Use c3270.sbcsCgcsgid for the single-byte (SBCS) character set.

Name: c3270.defaultFgBg
Type: Boolean
Default: false
Command Line: -defaultfgbg
Description:

If true, c3270 will use the terminal's default foreground color instead of specifying the curses color white, and it will use the terminal's default background color instead of specifying the curses color black. This is helpful in two cases: for emulators such as gnome-terminal whose usual representation of a black background is a murky gray, and for emulators configured with a black foreground and a white background, so that c3270's screen will appear the same way.

defaultFgBg will be set to true automatically if the environment variable COLORTERM is set to gnome-terminal.

Note that this resource and option are available only if c3270 has been compiled with a version of ncurses that supports default foreground and background colors, and if the terminal and its associated termcap/terminfo entry also support it (it is usually implemented as ANSI color 9).

Name: c3270.defScreen
Type: String
Command Line: -defscreen
Description:

Defines a character string that will be output to switch the terminal from 132-column mode to 80-column mode. Within the string, the sequence \E is translated to the ASCII ESC character (0x1b).

When c3270.model is 5, and this and c3270.altScreen are defined, c3270 will automatically change the terminal size when the host switches between the default (24x80) screen and the alternate (27x132) screen.

Name: c3270.dftBufferSize
Type: Integer
Default: 4096
Description:

Deprecated resource -- replaced by c3270.ftBufferSize

Specifies the default buffer size for DFT IND$FILE file transfers. This value can be overridden in the File Transfer dialog and by a parameter to the Transfer action.

Name: c3270.devName
Type: String
Command Line: -devname
Description:

Specifies the device name (workstation ID) sent in response to a TELNET NEW-ENVIRON sub-negotiation request, used by iSeries hosts (RFC 4777).

Name: c3270.dsTrace
Type: Boolean
Default: false
Command Line: -trace , -set dsTrace , -clear dsTrace
Description:

Deprecated resource -- replaced by c3270.trace

When true, c3270 writes a hexadecimal representation of all network traffic (and its interpretation) into a file, which defaults to x3trc.pid. The directory where the file is written is defined by c3270.traceDir. If c3270.traceFile is defined, it gives the entire pathname and c3270.traceDir is ignored.

Name: c3270.eof
Type: String
Default: ^D
Description:

This setting is used only in NVT mode, and is similar in function to the stty parameter of the same name.

When connected in line-at-a-time mode (when c3270 gathers a line of input before forwarding it to the host), entering this character at the keyboard causes the current line of input to be forwarded to the host without a trailing CR/LF sequence.

Name: c3270.erase
Type: String
Default: ^?
Description:

This setting is used only in NVT mode, and is similar in function to the stty parameter of the same name.

When connected in line-at-a-time mode (c3270 gathers a line of input before forwarding it ot the host), entering this character at the keyboard will cause c3270 to discard the last character on the input line.

When connected in character-at-a-time mode (c3270 sends each keystroke to the host as it is entered), this is the character that will be sent to the host by the Erase action.

Name: c3270.eventTrace
Type: Boolean
Default: false
Command Line: -set eventTrace , -clear eventTrace
Description:

Deprecated resource -- replaced by c3270.trace

When true, c3270 traces information about keyboard and mouse events into a file. The default file name is x3trc.pid. The directory where the file is written is defined by c3270.traceDir. If c3270.traceFile is defined, it gives the entire pathname and c3270.traceDir is ignored.

Name: c3270.extended
Type: Boolean
Default: false
Command Line: -extended
Description:

Deprecated resource -- replaced by c3270.model syntax

Indicates support for the 3270 Extended Data Stream.

Name: c3270.ftAllocation
Type: String
Default: default
Description:

Defines the default allocation type for files sent to TSO hosts by IND$FILE file transfers. Possible values are default, which lets the host decide the allocation type, or tracks, cylinders, or avblock.

Name: c3270.ftAvblock
Type: Integer
Description:

Defines the default AVBOCK (average block) allocation size for files sent to TSO hosts by IND$FILE file transfers.

Name: c3270.ftBlksize
Type: Integer
Description:

Defines the default block size for files sent to TSO hosts by IND$FILE file transfers.

Name: c3270.ftBufferSize
Type: Integer
Default: 4096
Description:

Specifies the default buffer size for DFT IND$FILE file transfers. This value can be overridden in the File Transfer dialog and by a parameter to the Transfer action.

Name: c3270.ftCr
Type: String
Default: auto
Description:

Defines the default action for line separators (carriage returns and line feeds) in ASCII files during IND$FILE file transfers. The value can be auto, which will add them when files are received from the host and remove them when they are sent to the host, add (same as auto), remove (same as auto), or keep, meaning no special processing is done.

Name: c3270.ftDirection
Type: String
Default: receive
Description:

Defines the default IND$FILE file transfer direction, from the perspective of the workstation. The value can be either send (send file from workstation to host) or receive (receive file from host to workstation).

Name: c3270.ftExist
Type: String
Default: keep
Description:

Defines the default behavior for IND$FILE file transfers when the destination file already exists. The value keep means that the transfer will be aborted, replace means that the file will be overwritten unconditionally, and append means that the new file will be appended to the old file.

Name: c3270.ftHost
Type: String
Default: tso
Description:

Defines the default host type for IND$FILE file transfers. The value can be vm, tso or cics.

Name: c3270.ftHostFile
Type: String
Description:

Defines the default host file name for IND$FILE file transfers.

Name: c3270.ftLocalFile
Type: String
Description:

Defines the default local file name for IND$FILE file transfers.

Name: c3270.ftLrecl
Type: Integer
Description:

Defines the default logical record length for files sent to the host via IND$FILE.

Name: c3270.ftMode
Type: String
Default: ascii
Description:

Defines the default mode for IND$FILE file transfers: ascii (text, with translation between the workstation's code page and EBCDIC), or binary (no translation).

Name: c3270.ftPrimarySpace
Type: Integer
Description:

Defines the default primary space allocation for files sent to TSO hosts via IND$FILE.

Name: c3270.ftRecfm
Type: String
Default: default
Description:

Defines the default record format for files sent to the host using IND$FILE. Possibe values are default, fixed, variable, and undefined. The default value of 'default' lets IND$FILE choose an appropriate format.

Name: c3270.ftRemap
Type: String
Default: yes
Description:

Defines the default mapping behavior for ASCII files transferred with IND$FILE. When set to yes, ASCII files are translated by c3270 to produce as accurate a mapping as possible between the workstation's code page and the host's EBCDIC code page. When set to no, only the fixed translation built into the IND$FILE application is run, which (roughly) maps ISO 8859-1 to host code page 37.

Name: c3270.ftSecondarySpace
Type: Integer
Description:

Defines the default secondary space allocation for files sent to TSO hosts via IND$FILE.

Name: c3270.hostname
Type: String
Description:

Gives the name of the host to connect to. The name can include the usual options (prefixes to specify special connection options, LU names, and port). A hostname specified on the command line takes precedence over c3270.hostname.

The most common use of c3270.hostname is in session files, where a file is used to pass all of the options to establish a c3270 session.

Name: c3270.hostsFile
Type: String
Default: /usr/local/etc/x3270/ibm_hosts
Description:

The pathname of a file containing hostname aliases. The file can also be used to define a set of actions to perform when connecting to a host.

The format of the file is explained on the ibm_hosts manual page. The default pathname is actually ibm_hosts in the directory defined by c3270.confDir.

Name: c3270.httpd
Type: String
Command Line: -httpd
Description:

Defines the TCP port and optional address to listen on for HTTP connections. (c3270 implements a simple REST API and a set of HTML objects for access by scripts.) The syntax of this resource is [address:]port, where address is an IPv4 or IPv6 address such as 127.0.0.1 or 0.0.0.0, and port is a TCP port such as 4080. The address can also be specified as * to indicate 0.0.0.0. A numeric IPv6 address must be enclosed in square brackets, e.g., [1234:5678::3], to avoid ambiguity between the colons inside the address and the colon separating the address from the port. If no address is specified, it defaults to 127.0.0.1.

Name: c3270.icrnl
Type: Boolean
Default: true
Description:

This setting is used only in NVT mode, and is similar in function to the stty parameter of the same name. It controls whether input carriage returns are mapped to newlines.

Name: c3270.idleCommand
Type: String
Description:

When c3270.idleCommand is defined, it specifies a command to execute after a period of keyboard inactivity (no AID keys pressed). The c3270.idleCommand can be an arbitrary sequence of c3270 actions, but it should include an action which generates an AID (Enter, Clear, PF or PA). c3270.idleCommandEnabled must be true in order for the c3270.idleCommand to take effect. (This is so an idle command can be defined, but needs to be enabled explicitly at some point after login.) c3270.idleTimeout specifies the inactivity interval.

Name: c3270.idleCommandEnabled
Type: Boolean
Default: false
Description:

Controls whether c3270.idleCommand has effect as soon as a host session is established. (This is so an idle command can be defined, but needs to be explicitly enabled at some point after login.)

Name: c3270.idleTimeout
Type: String
Default: ~7m
Description:

The timeout value for c3270.idleCommand. If the value ends in h, it specifies hours; if it ends in m it specifies minutes; if it ends in s or does not have an alphanumeric suffix, it specifies seconds.

If the value begins with a tilde ~, the time will be randomly varied +/-10% from the value specified.

Name: c3270.inlcr
Type: Boolean
Default: false
Description:

This setting is used only in NVT mode, and is similar in function to the stty parameter of the same name. It controls whether input newlines are mapped to carriage returns.

Name: c3270.intr
Type: String
Default: ^C
Description:

This setting is used only in NVT mode, and is similar in function to the stty parameter of the same name. When this character is typed on the keyboard, the TELNET IP (Interrupt Process) sequence is sent to the host.

Name: c3270.keyFile
Type: String
Command Line: -keyfile
Description:

Gives the name of a file containg the private key for the certificate specified by c3270.certFile or c3270.chainFile. The default file type is PEM; it can be overridden by c3270.keyFileType. If the private key is encrypted, the password is specified by c3270.keyPasswd. (OpenSSL only)

Name: c3270.keyFileType
Type: String
Default: pem
Command Line: -keyfileType
Description:

Gives the type of the private key file specified by c3270.keyFile. The value can be pem or asn1. (OpenSSL only)

Name: c3270.keymap
Type: String
Command Line: -keymap
Description:

The name of the keyboard map to use. It can be a single keymap name or a comma-separated list of keymaps, which will be applied in order.

Each keymap can optionally be defined in three separate parts: a common keymap, which is applied at all times, an NVT-mode keymap, which is applied only in NVT mode, and a 3270-mode keymap, which is only applied in 3270 mode. The NVT-mode keymap has the same name as the common keymap, with the suffix .nvt appended. The 3270-mode keymap has the suffix .3270 appended. Thus specifying a c3270.keymap value of foo implies the use of three different keymaps (if found): foo, foo.nvt and foo.3270.

c3270.keymap is only the name; the actual keymap for name foo can be defined either by the resource c3270.keymap.foo, or by a keymap file. The keymap file is not searched for in any particular location, nor does it have a special suffix, so c3270.keymap can specify the full pathname of the keymap file.

Name: c3270.keymap.foo
Type: String
Description:

The definition of keymap foo. Please refer to the How To Create a Custom Keymap document for a full description of the syntax.

Name: c3270.keyPasswd
Type: String
Command Line: -keypasswd
Description:

On OpenSSL, gives the password for the private key file specified by c3270.keyFile, if it is encrypted. The value can take one of two forms. file:filename specifies that the password is in a file. string:string gives the password value in the resource itself.

On the Mac, this gives the password for the c3270.certfile certifiate file.

Name: c3270.kill
Type: String
Default: ^U
Description:

This setting is used only in NVT mode, and is similar in function to the stty parameter of the same name.

When connected in line-at-a-time mode (when c3270 gathers a line of input before forwarding it to the host), entering this character at the keyboard causes the current input line to be erased.

When connected in character-at-a-time mode (when c3270 sends each keystroke to the host), this is the ASCII character that is sent to the host by the DeleteField action.

Name: c3270.lineWrap
Type: Boolean
Default: true
Command Line: -set lineWrap , -clear lineWrap
Description:

This setting is used only in NVT mode. When true, c3270 will automatically insert a CR/LF sequence when output reaches the end of a line. When false, output will pile up at the end of each line until the host sends a CR/LF sequence.

Name: c3270.loginMacro
Type: String
Command Line: -loginmacro
Description:

Defines a sequence of commands to run as soon as a host connection is established. Usually these would be commands used to navigate through login screens, such String, Tab and Enter.

If a c3270.hostsFile is in use and a matching entry is found, the login macro from that entry will be used in preference to the c3270.loginMacro.

Name: c3270.lnext
Type: String
Default: ^V
Description:

This setting is used only in NVT mode, and is similar in function to the stty parameter of the same name.

When connected in line-at-a-time mode (when c3270 gathers a line of input before forwarding it to the host), entering this character at the keyboard removes any special meaning from the next character entered.

Name: c3270.m3279
Type: Boolean
Default: true
Command Line: -color
Description:

Deprecated resource -- replaced by c3270.model syntax

Indicates support for color (a 3279 terminal).

Name: c3270.menuBar
Type: Boolean
Default: true
Description:

If false, the menu bar will not be displayed at the top of the c3270 display, even if the terminal supports a mouse.

Name: c3270.metaEscape
Type: Boolean
Default: true
Description:

When true, c3270 will assume that pressing a key while holding down the Alt key will cause the terminal to transmit the ASCII ESC character (0x1b) before the key. Thus c3270 will interpret ESC-x as Alt-x.

When false, ESC is treated like any other input character.

Name: c3270.model
Type: String
Default: 3279-4-E
Command Line: -model
Description:

The terminal model that c3270 is emulating. The model is in three parts, separated by dashes; each part is optional.

- 3278 or 3279
  3278 specifies a monochrome (green) 3270 display.
  3279 specifies a color 3270 display.
- 2, 3, 4 or 5 The model number, which determines the size of the screen. Model 2 has 24 rows and 80 columns. Model 3 has 32 rows and 80 columns. Model 4 has 43 rows and 80 columns. Model 5 has 27 rows and 132 columns. The default is the largest model that will fit on the console or terminal emulator window where c3270 is running. Displaying the OIA (status line) requires one more row than what is listed above.
- E An optional suffix which indicates support for the 3270 Extended Data Stream (color, extended attributes, Query Reply). 3279 implies E.

Name: c3270.mono
Type: Boolean
Default: false
Command Line: -mono
Description:

If true, c3270 will emulate a 3278, and will not use any of the terminal's color attributes.

Name: c3270.monoCase
Type: Boolean
Default: false
Command Line: -set monoCase , -clear monoCase
Description:

When true, causes c3270 to run in uppercase-only mode.

Name: c3270.mouse
Type: Boolean
Default: true
Description:

If true, enables c3270 to accept mouse-control events on terminals and emulators that support them. This allows a left mouse click to move the cursor. On terminals like xterm and gnome-terminal, this means that the usual mouse selection actions must be performed with the Shift key pressed. If false, mouse-control events will not be enabled.

Name: c3270.newEnviron
Type: Boolean
Default: true
Description:

If true, c3270 will respond to the TELNET NEW-ENVIRONMENT option. If false, it will not.

Name: c3270.noPrompt
Type: Boolean
Default: false
Description:

If true, the interactive c3270> prompt will be disabled. In particular, this means that when c3270 is not connected to a host, a keymap or an external script is the only way to start a new host connection.

Name: c3270.nopSeconds
Type: Integer
Description:

If nonzero, c3270 will send a TELNET NOP to the host every n seconds. This can be used to keep host sessions running that would otherwise be terminated due to inactivity.

Name: c3270.numericLock
Type: Boolean
Default: false
Description:

When true, causes c3270 to lock the keyboard when non-numeric data is entered into fields with the Numeric attribute.

Name: c3270.nvtMode
Type: Boolean
Default: false
Command Line: -nvt
Description:

When true, causes c3270 to start immediately in NVT mode and allow keyboard input immediately, instead of waiting for the host to send data or negotiate 3270 mode. It also causes the default terminal type to be xterm.

NVT mode can also be selected per session by prepending an A: onto the hostname.

Name: c3270.onlcr
Type: Boolean
Default: true
Description:

Used only in NVT line-at-a-time mode; similar to the stty parameter of the same name. It controls whether output newlines are mapped to CR/LF sequences.

Name: c3270.oerrLock
Type: Boolean
Default: true
Description:

If true, operator errors (typing into protected fields, insert overflow, etc.) will cause the keyboard to lock with an error message in the OIA (status line). If false, these errors will simply cause the terminal bell will ring, without any keyboard lock or message.

Name: c3270.once
Type: Boolean
Default: false
Command Line: -once
Description:

When true, c3270 will exit as soon as a host disconnects. The default is false if no hostname is specified on the command line or in a session file, true otherwise.

Name: c3270.oversize
Type: String
Command Line: -oversize
Description:

Sets the screen dimensions to be larger than the default for the chosen model. Its value is a string in the format colsxrows. It can also be the string auto, which will cause c3270 to use the entire screen area of the terminal. It is used only if the c3270.model includes the "-E" (extended data stream) suffix, and only if the specified dimensions are larger than the model number defaults. Also, only hosts that support the Query Reply structured field will function properly with c3270 in this mode.

Name: c3270.port
Type: String
Default: telnet
Command Line: -port
Description:

The name of the default TCP port for c3270 to connect to. This can be either a symbolic name from /etc/services, or an integer.

Name: c3270.proxy
Type: String
Command Line: -proxy
Description:

Defines a proxy server that c3270 will use to connect to hosts. The value is of the form type:server[:port], where options for type are described on the c3270 manual page.

Name: c3270.printerLu
Type: String
Command Line: -printerlu
Description:

If a value is set, c3270 will automatically start a pr3287 printer session when a host connection is established. If the value is ".", the pr3287 session will be associated with the interactive terminal session (this requires that the host supports TN3270E). Otherwise, the value is taken as the LU name to associate with the printer session.

Name: c3270.printer.assocCommandLine
Type: String
Default: pr3287 -assoc %L% -command %C% %R% %P% %V% %S% %O% %H%
Description:

Note: This resource is for debug purposes only. To add optional parameters to the wc3270 command line, use c3270.printer.options.

The shell command to use to start a printer session, when associated with the current TN3270E session LU (when c3270.printerLU is "."). Within the string, the following substitutions are made:

- %C% is replaced with the c3270.printer.command
- %H% is replaced with the current host name
- %L% is replaced with the current session's LU
- %O% is replaced with the value of c3270.printer.options
- %P% is replaced with the current session's proxy option (c3270.proxy)
- %R% is replaced with an option to pass the current character set
- %S% is replaced with an option to pass the port of the sync socket
- %V% is replaced with SSL-related options

Name: c3270.printer.command
Type: String
Default: lpr
Description:

The name of the command supplied to the "-command" option of the pr3287 program to print each job. This is the text which is substituted for %C in c3270.printer.assocCommandLine and c3270.printer.luCommandLine resources.

Name: c3270.printer.luCommandLine
Type: String
Default: pr3287 -command %C% %R% %P% %V% %S% %O% %L%@%H%
Description:

Note: This resource is for debug purposes only. To add optional parameters to the wc3270 command line, use c3270.printer.options.

The shell command to use to start a printer session, when associated with a specific LU. Within the string, the following substitutions are made:

- %C% is replaced with c3270.printer.command
- %H% is replaced with the current host name
- %L% is replaced with the LU value entered into the dialog box
- %O% is replaced with the value of c3270.printer.options
- %P% is replaced with current session's proxy option (c3270.proxy)
- %R% is replaced with an option to pass the current character set
- %S% is replaced with an option to pass the port of the sync socket
- %V% is replaced with SSL-related options

Name: c3270.printer.options
Type: String
Description:

Defines extra parameters to substutute for the %O% token in the printer command line.

Name: c3270.printTextCommand
Type: String
Default: lpr
Description:

The shell command used by the PrintText action. An ASCII image of the 3270 display becomes the standard input to this command.

Name: c3270.printTextScreensPerPage
Type: Integer
Default: 1
Description:

The number of screens to display on a page when tracing screens to the printer.

Name: c3270.qrBgColor
Type: Boolean
Default: false
Description:

When true, c3270 will report in the QueryReply(color) that it supports background color; when false, it will not. It is disabled by default because certain versions of GDDM are confused by this report and will crash.

Name: c3270.quit
Type: String
Default: ^\
Description:

This setting is used only in NVT mode, and is similar in function to the stty parameter of the same name. When connected in line-at-a-time mode (when c3270 gathers a line of input before forwarding it to the host), entering this character at the keyboard causes the TELNET BREAK sequence to be sent to the host.

Name: c3270.reconnect
Type: Boolean
Default: false
Description:

When true, c3270 will automatically reconnect to a host after it disconnects.

Name: c3270.reverseVideo
Type: Boolean
Default: false
Description:

When true, c3270 will use a white background instead of a black one.

Name: c3270.rprnt
Type: String
Default: ^R
Description:

This setting is used only in NVT mode, and is similar in function to the stty parameter of the same name. When connected in line-at-a-time mode (when c3270 gathers a line of input before forwarding it to the host), entering this character at the keyboard causes the current input line to be redisplayed.

Name: c3270.saveLines
Type: Integer
Default: 4096
Command Line: -sl
Description:

The number of display lines to save for the scroll bar. Note that the scroll bar operates on full screens of data, so the value divided by the number of rows on the screen gives you the number of screens that will be saved.

Name: c3270.sbcsCgcsgid
Type: String
Description:

Overrides the compiled-in value of the CGCSGID for the current host character set. The value is an integer, which can be prefixed with '0x' to be in hexadecimal. The upper 16 bits are the GCSGID (character set) and the lower 16 bits are the CPGID (code page). This value applies only to the single-byte (SBCS) character set. Use c3270.dbcsCgcsgid for the double-byte (DBCS) character set.

Name: c3270.screenTrace
Type: Boolean
Default: false
Command Line: -set screenTrace , -clear screenTrace
Description:

When true, c3270 will save an ASCII version of the screen image in a file every time it changes. The file name defaults to x3scr.pid. The directory where the file is written is defined by c3270.traceDir. If c3270.screenTraceFile is defined, it defines the file name and c3270.traceDir is ignored.

Name: c3270.screenTraceFile
Type: String
Description:

If defined, gives the name of the file that screen traces will be written into.

Name: c3270.scriptPort
Type: Integer
Command Line: -scriptport
Description:

If defined, c3270 will accept script connections on the specified local TCP port. The rules for the commands passed over these connections are documented in the x3270-script manual page. The syntax of this resource is [address:]port, where address is an IPv4 or IPv6 address such as 127.0.0.1 or 0.0.0.0, and port is a TCP port such as 4081. The address can also be specified as * to indicate 0.0.0.0. A numeric IPv6 address must be enclosed in square brackets, e.g., [1234:5678::3], to avoid ambiguity between the colons inside the address and the colon separating the address from the port. If no address is specified, it defaults to 127.0.0.1.

Name: c3270.scriptPortOnce
Type: Boolean
Default: false
Command Line: -scriptportonce
Description:

If defined, c3270 will accept only one script connection. When that connection is broken, it will exit.

Name: c3270.socket
Type: Boolean
Default: false
Command Line: -socket
Description:

When true, c3270 will create a Unix-domain socket than can be used by an external script to control the session. The name of the socket is /tmp/x3sck.pid. The -p option of the x3270if command can be used to connect to this socket.

Name: c3270.startTls
Type: Boolean
Default: true
Description:

If true, c3270 will accept the TELNET STARTTLS negotiation from the host. If false, it will reject them.

Name: c3270.suppressActions
Type: String
Description:

A list of whitespace-separated action names, with or without parentheses, which are to be ignored. The actions will be completely inaccessible, whether by keymaps, scripts, macros or the Execute an Action menu option. This resource is intended to be used as a security precaution for users who can define their own keymaps, but who do not have access to resource definitions or command-line options.

Name: c3270.termName
Type: String
Command Line: -tn
Description:

An alternate name to be sent in response to the host's TELNET DO OPTION TERMINAL-NAME request. The default is IBM-, followed by the value of c3270.model.

Name: c3270.trace
Type: Boolean
Default: false
Command Line: -trace , -set trace , -clear trace
Description:

When true, c3270 writes information about events and actions, as well as a hexadecimal representation of all network traffic (and its interpretation) into a file, which defaults to x3trc.pid. The directory where the file is written is defined by c3270.traceDir. If c3270.traceFile is defined, it gives the entire pathname and c3270.traceDir is ignored.

Name: c3270.traceDir
Type: String
Default: /tmp
Description:

Defines the directory that trace files are written into.

Name: c3270.traceFile
Type: String
Command Line: -tracefile
Description:

If defined, gives the name of the file that data stream and event traces will be written into. If it begins with ">>", data will be appended to the file.

Name: c3270.traceFileSize
Type: String
Command Line: -tracefilesize
Description:

If defined, gives a limit on the size of the file that data stream and event traces will be written into. If not defined, or defined as 0, there will be no limit on the size of the file. The value is a number, followed by an optional suffix. If the suffix is K (e.g., 128K), the value will be multiplied by 1024. If the suffix is M, the value will be multiplied by (1024*1024). The size limit enforced at operation boundaries, not per byte, so the actual file may grow slightly larger. When the file size exceeds the limit, the trace file will be renamed with a "-" appended and a new file started.

Name: c3270.typeahead
Type: Boolean
Default: true
Description:

When true, c3270 will store keystrokes in a buffer when the keyboard is locked. When false, these keystrokes will be dropped.

Name: c3270.underscore
Type: Boolean
Default: false
Command Line: -set underscore , -clear underscore
Description:

When true, c3270 will display fields with the underlined attribute in a special way: blank characters will be translated to underscore (_) characters. This is needed on terminals that are unable to display real underlined text.

Name: c3270.unlockDelay
Type: Boolean
Default: true
Description:

When c3270 sends the host an AID (the Enter, Clear, PF or PA actions), it locks the keyboard until the host sends a reply to unlock it. Some hosts unlock the keyboard before they are actually finished processing the command, which can cause scripts to malfunction subtly. To avoid this, c3270 implements a hack to briefly delay actually unlocking the keyboard. When c3270.unlockDelay is true (the default), the keyboard unlock will be delayed for c3270.unlockDelayMs milliseconds. Setting it to false removes this delay.

Name: c3270.unlockDelayMs
Type: Integer
Default: 350
Description:

Overrides the default value for the unlock delay (the delay between the host unlocking the keyboard and c3270 actually performing the unlock). The value is in milliseconds; use 0 to turn off the delay completely, including for macros.

Name: c3270.user
Type: String
Command Line: -user
Description:

Specifies the user name sent in response to a TELNET NEW-ENVIRON sub-negotiation request, used by iSeries hosts (RFC 4777).

Name: c3270.verifyHostCert
Type: Boolean
Default: true
Command Line: -noverifycert , -verifycert
Description:

If true (the default), c3270 will verify SSL/TLS host certificates, and not allow an SSL/TLS connection to complete unless the host certificate can be validated. If false, c3270 will not verify SSL/TLS host certificates.

This resource is overridden by a y: prepended to the hostname when connecting, which disables certificate checking.

Name: c3270.visibleControl
Type: Boolean
Default: false
Command Line: -set visibleControl , -clear visibleControl
Description:

If true, certain control characters, which are normally displayed as blanks, are displayed on the screen.

EBCDIC control characters, displayed with underlines, are as follows:

Character | Meaning
--- | ---
. | NUL (X'00')
< | The SO character (begins a DBCS subfield)
> | The SI character (ends a DBCS subfield)

3270 field attributes, displayed in yellow with underlines, are decoded as follows:

Character | Protected | Numeric | Display | Selectable | Modified
--- | --- | --- | --- | --- | ---
0 | - | - | normal | - | -
1 | - | - | normal | - | modified
2 | - | - | normal | selectable | -
3 | - | - | normal | selectable | modified
4 | - | - | intensified | selectable | -
5 | - | - | intensified | selectable | modified
6 | - | - | nondisplay | - | -
7 | - | - | nondisplay | - | modified
8 | - | numeric | normal | - | -
9 | - | numeric | normal | - | modified
A | - | numeric | normal | selectable | -
B | - | numeric | normal | selectable | modified
C | - | numeric | intensified | selectable | -
D | - | numeric | intensified | selectable | modified
E | - | numeric | nondisplay | - | -
F | - | numeric | nondisplay | - | modified
G | protected | - | normal | - | -
H | protected | - | normal | - | modified
I | protected | - | normal | selectable | -
J | protected | - | normal | selectable | modified
K | protected | - | intensified | selectable | -
L | protected | - | intensified | selectable | modified
M | protected | - | nondisplay | - | -
N | protected | - | nondisplay | - | modified
O | protected | numeric | normal | - | -
P | protected | numeric | normal | - | modified
Q | protected | numeric | normal | selectable | -
R | protected | numeric | normal | selectable | modified
S | protected | numeric | intensified | selectable | -
T | protected | numeric | intensified | selectable | modified
U | protected | numeric | nondisplay | - | -
V | protected | numeric | nondisplay | - | modified

Name: c3270.werase
Type: String
Default: ^W
Description:

This setting is used only in NVT mode, and is similar in function to the stty parameter of the same name. When connected in line-at-a-time mode (when c3270 gathers a line of input before forwarding it to the host), entering this character at the keyboard erases the last word of input.

When connected in character-at-a-time mode (when c3270 sends each keystroke to the host), this is the ASCII character that is sent to the host by the DeleteWord action.

## Index of All Resources

acceptHostname | acs | aidWait | allBold
altScreen | asciiBoxDraw | bindLimit | bindUnlock
blankFill | bsdTm | caDir | caFile
cbreak | certFile | certFileType | chainFile
charset | clientCert | color8 | composeMap
composeMap.foo | confDir | connectTimeout | crosshair
crosshairColor | cursesColorForDefault | cursesColorForIntensified | cursesColorForProtected
cursesColorForProtectedIntensified | cursesColorForHostColor0 | cursesColorForHostColorNeutralBlack | cursesColorForHostColor1
cursesColorForHostColorBlue | cursesColorForHostColor2 | cursesColorForHostColorRed | cursesColorForHostColor3
cursesColorForHostColorPink | cursesColorForHostColor4 | cursesColorForHostColorGreen | cursesColorForHostColor5
cursesColorForHostColorTurquoise | cursesColorForHostColor6 | cursesColorForHostColorYellow | cursesColorForHostColor7
cursesColorForHostColorNeutralWhite | cursesColorForHostColor8 | cursesColorForHostColorBlack | cursesColorForHostColor9
cursesColorForHostColorDeepBlue | cursesColorForHostColor10 | cursesColorForHostColorOrange | cursesColorForHostColor12
cursesColorForHostColorPurple | cursesColorForHostColor13 | cursesColorForHostColorPaleGreen | cursesColorForHostColor14
cursesColorForHostColorPaleTurquoise | cursesColorForHostColor15 | cursesColorForHostColorGrey | cursesColorForHostColor16
cursesColorForHostColorWhite | cursesKeypad | cursorPos | dbcsCgcsgid
defaultFgBg | defScreen | dftBufferSize | devName
dsTrace | eof | erase | eventTrace
extended | ftAllocation | ftAvblock | ftBlksize
ftBufferSize | ftCr | ftDirection | ftExist
ftHost | ftHostFile | ftLocalFile | ftLrecl
ftMode | ftPrimarySpace | ftRecfm | ftRemap
ftSecondarySpace | hostname | hostsFile | httpd
icrnl | idleCommand | idleCommandEnabled | idleTimeout
inlcr | intr | keyFile | keyFileType
keymap | keymap.foo | keyPasswd | kill
lineWrap | loginMacro | lnext | m3279
menuBar | metaEscape | model | mono
monoCase | mouse | newEnviron | noPrompt
nopSeconds | numericLock | nvtMode | onlcr
oerrLock | once | oversize | port
proxy | printerLu | printer.assocCommandLine | printer.command
printer.luCommandLine | printer.options | printTextCommand | printTextScreensPerPage
qrBgColor | quit | reconnect | reverseVideo
rprnt | saveLines | sbcsCgcsgid | screenTrace
screenTraceFile | scriptPort | scriptPortOnce | socket
startTls | suppressActions | termName | trace
traceDir | traceFile | traceFileSize | typeahead
underscore | unlockDelay | unlockDelayMs | user
verifyHostCert | visibleControl | werase

## Basic Configuration Resources

charset | connectTimeout | hostname | keymap
model | port | proxy | printerLu

## Appearance Resources

allBold | crosshair | crosshairColor | cursesColorForDefault
cursesColorForIntensified | cursesColorForProtected | cursesColorForProtectedIntensified | cursesColorForHostColor0
cursesColorForHostColorNeutralBlack | cursesColorForHostColor1 | cursesColorForHostColorBlue | cursesColorForHostColor2
cursesColorForHostColorRed | cursesColorForHostColor3 | cursesColorForHostColorPink | cursesColorForHostColor4
cursesColorForHostColorGreen | cursesColorForHostColor5 | cursesColorForHostColorTurquoise | cursesColorForHostColor6
cursesColorForHostColorYellow | cursesColorForHostColor7 | cursesColorForHostColorNeutralWhite | cursesColorForHostColor8
cursesColorForHostColorBlack | cursesColorForHostColor9 | cursesColorForHostColorDeepBlue | cursesColorForHostColor10
cursesColorForHostColorOrange | cursesColorForHostColor12 | cursesColorForHostColorPurple | cursesColorForHostColor13
cursesColorForHostColorPaleGreen | cursesColorForHostColor14 | cursesColorForHostColorPaleTurquoise | cursesColorForHostColor15
cursesColorForHostColorGrey | cursesColorForHostColor16 | cursesColorForHostColorWhite | cursorPos
defaultFgBg | menuBar | reverseVideo | underscore

## NVT-Mode Resources

eof | erase | icrnl | inlcr
intr | kill | lineWrap | lnext
onlcr | quit | rprnt | werase

## Protocol Resources

bindLimit | bindUnlock | bsdTm | color8
dbcsCgcsgid | dftBufferSize | devName | ftBufferSize
sbcsCgcsgid | termName | user

## Terminal Interaction Resources

blankFill | ftAllocation | ftAvblock | ftBlksize
ftCr | ftDirection | ftExist | ftHost
ftHostFile | ftLocalFile | ftLrecl | ftMode
ftPrimarySpace | ftRecfm | ftRemap | ftSecondarySpace
idleCommand | idleCommandEnabled | idleTimeout | mouse
nopSeconds | numericLock | nvtMode | oerrLock

## Security Resources

acceptHostname | caDir | caFile | certFile
certFileType | chainFile | clientCert | keyFile
keyFileType | keyPasswd | noPrompt | startTls
suppressActions | verifyHostCert

## Tracing Resources

dsTrace | eventTrace | screenTrace | screenTraceFile
trace | traceDir | traceFile | traceFileSize

## Other Resources

acs | aidWait | altScreen | asciiBoxDraw
cbreak | composeMap | composeMap.foo | confDir
cursesKeypad | defScreen | hostsFile | httpd
keymap.foo | loginMacro | metaEscape | mono
monoCase | newEnviron | once | oversize
printer.assocCommandLine | printer.command | printer.luCommandLine | printer.options
printTextCommand | printTextScreensPerPage | qrBgColor | reconnect
saveLines | scriptPort | scriptPortOnce | socket
typeahead | unlockDelay | unlockDelayMs | visibleControl

## Deprecated Resources

extended | m3279

c3270 version 3.6ga5 Sat Feb 10 16:10:02 CST 2018